local NameplateThreat = LibStub('AceAddon-3.0'):NewAddon('NameplateThreat', 'AceEvent-3.0', 'AceConsole-3.0')
_G.NameplateThreat = NameplateThreat

--~ local L = LibStub('AceLocale-3.0'):GetLocale('NameplateThreat', true)

---------------   initialize   ---------------

--~ local defaults = {
--~    profile = {
--~       enabled = true,
--~    },
--~ }

function NameplateThreat:OnInitialize()
--~    local db = LibStub('AceDB-3.0'):New('NameplateThreatDB', defaults, 'Default')
--~    self.db = db

--~    db.RegisterCallback(self, 'OnProfileChanged', 'OnEnable')
--~    db.RegisterCallback(self, 'OnProfileCopied', 'OnEnable')
--~    db.RegisterCallback(self, 'OnProfileReset', 'OnEnable')

--~    self:RegisterOptions()

   self.debugging = true

   hooksecurefunc('SetCVar', self.SetCVar)
end

function NameplateThreat:OnEnable()
--~    if not self.db.profile.enabled then
--~       return self:Disable()
--~    end

--~    self:RegisterEvent('UNIT_THREAT_LIST_UPDATE', 'THREAT_UPDATE')  -- don't need this accurate, yet
   self:RegisterEvent('UNIT_THREAT_SITUATION_UPDATE', 'THREAT_UPDATE')
   self:RegisterEvent('PARTY_MEMBERS_CHANGED')

   if GetCVarBool('nameplateShowEnemies') then
      self.updateFrame:Show()
   end
end

function NameplateThreat:OnDisable()
   self.updateFrame:Hide()
end

---------------   Events   ---------------

NameplateThreat.party = {
   'party1target','partypet1target','party2target','partypet2target','focus',
   'party3target','partypet3target','party4target','partypet4target','target','pettarget',
}
NameplateThreat.raid = {
   'raid1target','raidpet1target','raid2target','raidpet2target','raid3target','raidpet3target',
   'raid4target','raidpet4target','raid5target','raidpet5target','raid6target','raidpet6target',
   'raid7target','raidpet7target','raid8target','raidpet8target','raid9target','raidpet9target',
   'raid10target','raidpet10target','raid11target','raidpet11target','raid12target','raidpet12target',
   'raid13target','raidpet13target','raid14target','raidpet14target','raid15target','raidpet15target',
   'raid16target','raidpet16target','raid17target','raidpet17target','raid18target','raidpet18target',
   'raid19target','raidpet19target','raid20target','raidpet20target','raid21target','raidpet21target',
   'raid22target','raidpet22target','raid23target','raidpet23target','raid24target','raidpet24target',
   'raid25target','raidpet25target','raid26target','raidpet26target','raid27target','raidpet27target',
   'raid28target','raidpet28target','raid29target','raidpet29target','raid30target','raidpet30target',
   'raid31target','raidpet31target','raid32target','raidpet32target','raid33target','raidpet33target',
   'raid34target','raidpet34target','raid35target','raidpet35target','raid36target','raidpet36target',
   'raid37target','raidpet37target','raid38target','raidpet38target','raid39target','raidpet39target',
   'raid40target','raidpet40target','target','pettarget','focus',
}

function NameplateThreat:PARTY_MEMBERS_CHANGED()
	if GetNumRaidMembers() > 0 then
      self.group = self.raid
	elseif GetNumPartyMembers() > 0 then
      self.group = self.party
   else
--~       self.group = nil
      self.group = self.party -- for testing
      -- not in group, disable
   end
end

NameplateThreat.group = NameplateThreat.party -- for testing

function NameplateThreat:THREAT_UPDATE(event, unitid, ...)
--~    if not unitid then return end
   self:debug(0, event, unitid, ...)
--~    if not self.group then return end -- for testing

   -- loop thru all party/raid&pet targets
   local threat = {}
   local found = {}
   local name
   for i,unit in ipairs(self.group) do
      -- add name..hp = unit (party5target etc) to table  -- use lvl or maxhp?
      name = UnitName(unit)
      if name and not found[unit] then
         self:debug(1, name)
         threat[name..UnitHealth(unit)] = unit
         found[unit] = true
      end
   end

   self.threatTable = threat

   -- add an onupdate function to nameplate threat
   -- check table for match, and update display
end

function NameplateThreat.SetCVar(cvar, val)
   if cvar ~= 'nameplateShowEnemies' then return end

   if val == 1 then
      return NameplateThreat.updateFrame:Show()
   end
   NameplateThreat.updateFrame:Hide()
end

-- this is for the threat frame to use
function NameplateThreat:ThreatOnUpdate(elapsed)
   local t = self.elapsed + elapsed
   if t < 1 then  --for testing, use .1 otherwise
      self.elapsed = t
      return
   end
   self.elapsed = 0

   local threat = self.threat
   local NameplateThreat = self.NameplateThreat
   local threatTable = NameplateThreat.threatTable
--~    NameplateThreat:debug(0,"ThreatOnUpdate", threatTable)

   -- test if threat should be shown
   if threatTable then --and self.NameplateThreat.group then
      local _,_,_,_,_,_,name,lvl = self:GetRegions()
      local unit = threatTable[name:GetText()..self.health:GetValue()]
      if unit then
         local isTanking, status, percentage = UnitDetailedThreatSituation('player', unit)
         NameplateThreat:debug(1,isTanking, status, percentage)
         if percentage and percentage ~= 0 then
            threat.text:SetText(('%d%%'):format(percentage))
            threat.bg:SetVertexColor(GetThreatStatusColor(status))
            return threat:Show()
         end
      end
   end
   threat:Hide()
end

---------------   Core   ---------------

--don't use AceEvent to reduce overhead

local frame = CreateFrame('Frame')
NameplateThreat.updateFrame = frame
frame:Hide()

frame.interval = 1
frame.elapsed = 0
frame.numWFChildren = 1
frame.WorldFrame = WorldFrame
function frame:OnUpdate(elapsed)
   local t = self.elapsed + elapsed
   if t < self.interval then
      self.elapsed = t
      return
   end
   self.elapsed = 0

   local WorldFrame = self.WorldFrame
   local n = WorldFrame:GetNumChildren()
   if n > self.numWFChildren then
      self:ProcessChildren(self.select(self.numWFChildren+1, WorldFrame:GetChildren()))
      self.numWFChildren = n
   end
end
frame:SetScript('OnUpdate', frame.OnUpdate)

frame.select = select
frame.CreateFrame = CreateFrame
frame.NameplateThreat = NameplateThreat
function frame:ProcessChildren(...)
   local select = self.select
   for i=1,select('#',...) do
      self.CreateFrame('Frame', nil, select(i,...), 'NameplateThreatTemplate')
   end
end

--~ NameplateThreat.dataobj = LibStub:GetLibrary('LibDataBroker-1.1'):NewDataObject('NameplateThreat', {
--~    type = 'launcher',
--~    icon = 'Interface\\Buttons\\UI-GroupLoot-Dice-Up',
--~    tocname = 'NameplateThreat',
--~    label = 'NameplateThreat',
--~    OnTooltipShow = function(tooltip)
--~       tooltip:AddLine('NameplateThreat')
--~    end,
--~ })

function NameplateThreat:debug(level, ...)
   if self.debugging then
      print(strrep('   ', level), ...)
   end
end
