local NameplateThreat = NameplateThreat
local L = LibStub('AceLocale-3.0'):GetLocale('NameplateThreat', true)

function NameplateThreat:OptionGet(info)
   return self.db.profile[info.arg]
end

function NameplateThreat:OptionSet(info, value)
   self.db.profile[info.arg] = value
end

NameplateThreat.optionTable = {
   name = 'NameplateThreat',
   desc = L["Automatically roll on items."],
   type = 'group',
   handler = NameplateThreat,
   get = 'OptionGet',
   set = 'OptionSet',
   args = {
      desc = {
         name = L["Add threat display to nameplates."],
         type = 'description',
         order = 100,
         width = 'full',
      },
      [ENABLE] = {
         name = ENABLE,
         type = 'toggle',
         order = 200,
         get = 'IsEnabled',
         width = 'full',
         set = function (info, v)
            local self = info.handler
            self.db.profile.enabled = v
            if v then
               self:Enable()
            else
               self:Disable()
            end
         end,
      },
   }
}

function NameplateThreat:RegisterOptions()
   local options = self.optionTable
--~    local profile = LibStub('AceDBOptions-3.0'):GetOptionsTable(self.db)

   local registry = LibStub('AceConfigRegistry-3.0')
   local dialog = LibStub('AceConfigDialog-3.0')
   LibStub('AceConfig-3.0'):RegisterOptionsTable('NameplateThreat', options, 'NameplateThreat')

   registry:RegisterOptionsTable('NameplateThreat Options', options)
--~    registry:RegisterOptionsTable('NameplateThreat Profiles', profile)

   local main = dialog:AddToBlizOptions('NameplateThreat Options', 'NameplateThreat')
   self.optionsFrames = {
      main = main,
--~       profiles = dialog:AddToBlizOptions('NameplateThreat Profiles', 'Profiles', 'NameplateThreat'),
   }

   if self.dataobj then
      self.dataobj.OnClick = function() InterfaceOptionsFrame_OpenToCategory(main) end
   end
end
